--[[
Author: Starinnia
Helper mod for the Shocking! Achievement for Thaddius in Naxx
Project version: r32
$Date: 2009-04-01 01:47:21 +0000 (Wed, 01 Apr 2009) $
$Revision: 32 $
]]

ChargeMeter = LibStub("AceAddon-3.0"):NewAddon("ChargeMeter", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0")

local p2_trig1 = "Eat... your... bones..."
local p2_trig2 = "Break... you!!"
local p2_trig3 = "Kill..."

local tinsert = table.insert
local tconcat = table.concat

local str = {}
local function concat(t, sym)
	wipe(str)
	
	for k, v in pairs(t) do
		if v > 1 then
			tinsert(str, k.."("..v..")")
		else
			tinsert(str, k)
		end
	end
	
	return tconcat(str, sym)
end

function ChargeMeter:OnInitialize()
	self.PosCharges = {}
	self.NegCharges = {}
	self.scanning = false
	
	_G["SlashCmdList"]["CHARGEMETER_MAIN"] = self.PLAYER_REGEN_ENABLED
	_G["SLASH_CHARGEMETER_MAIN1"] = "/cmeter"
end

function ChargeMeter:OnEnable()
	--self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED", "CombatLog")
	self:RegisterEvent("CHAT_MSG_MONSTER_YELL")
end

function ChargeMeter:CHAT_MSG_MONSTER_YELL(event, msg)
	if msg:find(p2_trig1) or msg:find(p2_trig2) or msg:find(p2_trig3) then
		--only activate if player is leader or promoted, hopefully multiple promoted people won't run the addon
		if IsRaidLeader() or IsRaidOfficer() then
			self.scanning = true
			self:RegisterEvent("PLAYER_REGEN_ENABLED")
			self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED", "CombatLog")
		end
	end
end

function ChargeMeter:PLAYER_REGEN_ENABLED()
	self:UnregisterEvent("PLAYER_REGEN_ENABLED")
	self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self.scanning = false
	
	--wipe tables for safety
	wipe(self.PosCharges)
	wipe(self.NegCharges)
	--double check timer is wiped too
	self:CancelTimer(self.timer, true)
	self.timer = nil
end

function ChargeMeter:CombatLog(event, timestamp, subevent, sID, sName, sFlags, dID, dName, dFlags, spellID, spellName)
	if not self.scanning then return end
	if subevent == "SPELL_DAMAGE" then
		if spellID == 28062 then -- positive charge attack
			if not self.timer then self.timer = self:ScheduleTimer("PrintCharges", 1.5) end
			if not self.PosCharges[sName] then self.PosCharges[sName] = 1 end
			self.PosCharges[sName] = self.PosCharges[sName] + 1
		end
		if spellID == 28085 then --negative charge attack
			if not self.timer then self.timer = self:ScheduleTimer("PrintCharges", 1.5) end
			if not self.NegCharges[sName] then self.NegCharges[sName] = 1 end
			self.NegCharges[sName] = self.NegCharges[sName] + 1
		end
	end
end

function ChargeMeter:PrintCharges()
	--wipe timers
	self:CancelTimer(self.timer, true)
	self.timer = nil
	
	--print the tables to chat
	SendChatMessage("<CMeter> Crossed Charges!", "RAID")
	SendChatMessage("<CMeter> " .. concat(self.PosCharges, " (+), ") .. "(+)", "RAID")
	SendChatMessage("<CMeter> " .. concat(self.NegCharges, " (-), ") .. "(-)", "RAID")
	
	--wipe tables
	wipe(self.PosCharges)
	wipe(self.NegCharges)
end
